#ifndef MESH_H
#define MESH_H

#define NODECOUNT 36
#define TRICOUNT 72

#define NODE(a, b) (long)(nodes[a][b])
#define EDGE(a, b) (faces[a][b])

const long nodes[NODECOUNT][3] = {
  {(long)(32.16*PRES), (long)(0.0*PRES), (long)(0.0*PRES)},
  {(long)(16.08*PRES), (long)(27.8514*PRES), (long)(0.0*PRES)},
  {(long)(14.04*PRES), (long)(24.318*PRES), (long)(7.0668*PRES)},
  {(long)(28.08*PRES), (long)(0.0*PRES), (long)(7.0668*PRES)},
  {(long)(9.96*PRES), (long)(17.2512*PRES), (long)(7.0668*PRES)},
  {(long)(19.92*PRES), (long)(0.0*PRES), (long)(7.0668*PRES)},
  {(long)(7.92*PRES), (long)(13.7178*PRES), (long)(0.0*PRES)},
  {(long)(15.84*PRES), (long)(0.0*PRES), (long)(0.0*PRES)},
  {(long)(9.96*PRES), (long)(17.2512*PRES), (long)(-7.0668*PRES)},
  {(long)(19.92*PRES), (long)(0.0*PRES), (long)(-7.0668*PRES)},
  {(long)(14.04*PRES), (long)(24.318*PRES), (long)(-7.0668*PRES)},
  {(long)(28.08*PRES), (long)(0.0*PRES), (long)(-7.0668*PRES)},
  {(long)(-16.08*PRES), (long)(27.8514*PRES), (long)(0.0*PRES)},
  {(long)(-14.04*PRES), (long)(24.318*PRES), (long)(7.0668*PRES)},
  {(long)(-9.96*PRES), (long)(17.2512*PRES), (long)(7.0668*PRES)},
  {(long)(-7.92*PRES), (long)(13.7178*PRES), (long)(0.0*PRES)},
  {(long)(-9.96*PRES), (long)(17.2512*PRES), (long)(-7.0668*PRES)},
  {(long)(-14.04*PRES), (long)(24.318*PRES), (long)(-7.0668*PRES)},
  {(long)(-32.16*PRES), (long)(0.0*PRES), (long)(0.0*PRES)},
  {(long)(-28.08*PRES), (long)(0.0*PRES), (long)(7.0668*PRES)},
  {(long)(-19.92*PRES), (long)(0.0*PRES), (long)(7.0668*PRES)},
  {(long)(-15.84*PRES), (long)(0.0*PRES), (long)(0.0*PRES)},
  {(long)(-19.92*PRES), (long)(0.0*PRES), (long)(-7.0668*PRES)},
  {(long)(-28.08*PRES), (long)(0.0*PRES), (long)(-7.0668*PRES)},
  {(long)(-16.08*PRES), (long)(-27.8514*PRES), (long)(0.0*PRES)},
  {(long)(-14.04*PRES), (long)(-24.318*PRES), (long)(7.0668*PRES)},
  {(long)(-9.96*PRES), (long)(-17.2512*PRES), (long)(7.0668*PRES)},
  {(long)(-7.92*PRES), (long)(-13.7178*PRES), (long)(0.0*PRES)},
  {(long)(-9.96*PRES), (long)(-17.2512*PRES), (long)(-7.0668*PRES)},
  {(long)(-14.04*PRES), (long)(-24.318*PRES), (long)(-7.0668*PRES)},
  {(long)(16.08*PRES), (long)(-27.8514*PRES), (long)(0.0*PRES)},
  {(long)(14.04*PRES), (long)(-24.318*PRES), (long)(7.0668*PRES)},
  {(long)(9.96*PRES), (long)(-17.2512*PRES), (long)(7.0668*PRES)},
  {(long)(7.92*PRES), (long)(-13.7178*PRES), (long)(0.0*PRES)},
  {(long)(9.96*PRES), (long)(-17.2512*PRES), (long)(-7.0668*PRES)},
  {(long)(14.04*PRES), (long)(-24.318*PRES), (long)(-7.0668*PRES)},
};

const unsigned char faces[TRICOUNT][3] = {
  {0, 1, 2},
  {2, 3, 0},
  {3, 2, 4},
  {4, 5, 3},
  {5, 4, 6},
  {6, 7, 5},
  {7, 6, 8},
  {8, 9, 7},
  {9, 8, 10},
  {10, 11, 9},
  {0, 11, 10},
  {10, 1, 0},
  {1, 12, 13},
  {13, 2, 1},
  {2, 13, 14},
  {14, 4, 2},
  {4, 14, 15},
  {15, 6, 4},
  {6, 15, 16},
  {16, 8, 6},
  {8, 16, 17},
  {17, 10, 8},
  {10, 17, 12},
  {12, 1, 10},
  {12, 18, 19},
  {19, 13, 12},
  {13, 19, 20},
  {20, 14, 13},
  {14, 20, 21},
  {21, 15, 14},
  {15, 21, 22},
  {22, 16, 15},
  {16, 22, 23},
  {23, 17, 16},
  {17, 23, 18},
  {18, 12, 17},
  {18, 24, 25},
  {25, 19, 18},
  {19, 25, 26},
  {26, 20, 19},
  {20, 26, 27},
  {27, 21, 20},
  {21, 27, 28},
  {28, 22, 21},
  {22, 28, 29},
  {29, 23, 22},
  {23, 29, 24},
  {24, 18, 23},
  {24, 30, 31},
  {31, 25, 24},
  {25, 31, 32},
  {32, 26, 25},
  {26, 32, 33},
  {33, 27, 26},
  {27, 33, 34},
  {34, 28, 27},
  {28, 34, 35},
  {35, 29, 28},
  {29, 35, 30},
  {30, 24, 29},
  {30, 0, 3},
  {3, 31, 30},
  {31, 3, 5},
  {5, 32, 31},
  {32, 5, 7},
  {7, 33, 32},
  {33, 7, 9},
  {9, 34, 33},
  {34, 9, 11},
  {11, 35, 34},
  {0, 30, 35},
  {35, 11, 0},
};

#endif // MESH_H
